﻿# *************************************************************************************** #
# Get SPF Vms Custom Properties Command 
# *************************************************************************************** #

# *************************************************************************************** #
# Params in @(paramName) will be replaced by vConnect. These are standard, DO NOT CHANGE
# *************************************************************************************** #
 
# Common Functions - Do not Remove this
. .\SpfExtensionsCommon.ps1

try 
{ 
    Import-Module VirtualMachineManager
    $vmmServer = VConnect-Connect-VMMServer

    $vmDetails = @()
    foreach ($vmInfo in $VMsInfo.VMList) 
    {
		if ($vmInfo.Id -ne $null) 
		{
			$vm = Get-SCVirtualMachine -Id $vmInfo.Id -VMMServer $vmmServer
		}
		else
		{
			$vm = Get-SCVirtualMachine -Name $vmInfo.Name -VMMServer $vmmServer
		}
		if (!$vm) { continue; }

		$vmDetail = @{
			Name = $vmInfo.Name
			Id = $vmInfo.Id
			VMConfigId = $vmInfo.VMConfigId
			CustomProperties = @{}
		}
		$customProps = $vm.CustomProperty
		$vmDetail.CustomProperties = $customProps
		$vmDetails += New-Object PSObject -Property $vmDetail
    }
    return Get-ScriptResult $true 0 "Getting VMs custom properties succeeded" $vmDetails
}
catch 
{
    $errorMessage = $_.Exception.Message
    $exception = Get-FullLastError
    return Get-ScriptErrorResult $errorMessage $exception
}